package fr.emanation.ij.beanshellbox;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.actionSystem.DataConstants;
import com.intellij.openapi.actionSystem.Presentation;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.editor.SelectionModel;
import com.intellij.openapi.project.Project;

/**
 * <dl>
 * <dt><b>Creation date :</b></dt>
 * <dd>21 sept. 2006</dd>
 *
 * @author cedric
 *         </dl>
 */
public class BeanShellThisAction extends AnAction {

	public void update(AnActionEvent e) {
		Presentation presentation = e.getPresentation();
		Project project = (Project) e.getDataContext().getData(DataConstants.PROJECT);
		if (project==null) {
			presentation.setEnabled(false);
			return;
		}
		Editor editor = (Editor) e.getDataContext().getData(DataConstants.EDITOR);
		if (editor==null) {
			presentation.setEnabled(false);
			return;
		}
		SelectionModel smodel = editor.getSelectionModel();
		if (smodel==null) {
			presentation.setEnabled(false);
			return;
		}
		presentation.setEnabled(smodel.hasSelection());
	}

	public void actionPerformed(AnActionEvent e) {
		Project project = (Project) e.getDataContext().getData(DataConstants.PROJECT);
		if (project==null) return; // should not happen
		Editor editor = (Editor) e.getDataContext().getData(DataConstants.EDITOR);
		if (editor==null) return;
		SelectionModel smodel = editor.getSelectionModel();
		if (!smodel.hasSelection()) return;
		String script = smodel.getSelectedText();
		BeanShellConsole console = project.getComponent(BeanShellConsole.class);
		if (console==null) return;
		console.eval(script);
		console.expandPanel();
	}
}
